/****************************************************************************
*
* (C) 2000 by PWR Solutions GbR
*
*  PWR Solutions GbR
*  Euckenstrasse 17
*  D-81369 Mnchen
*
*  Phone : (49)-89-726092-30
*  Fax   : (49)-89-726092-59

$Header: i2c_api.h, 5, 16.01.2002 10:11:07, Christoph Stoidner$

*
* ---------------------------------------------------------------------------
* Module        : I2C_API.H
* Function      : Defines and typedefs for I2C_API.C
*
* Compiler      : Borland C++ 5.0
* Memorymodel   : Large
*
* Author        : Bernhard Roth
* Date          : 17.07.00
* Version       : V1.00
* ---------------------------------------------------------------------------

$Log: 
 5    IPC@CHIP  1.4         16.01.2002 10:11:07  Christoph Stoidner add starteam
      directives
 4    IPC@CHIP  1.3         16.01.2002 10:09:09  Christoph Stoidner add new
      functions and comments
 3    IPC@CHIP  1.2         13.08.2001 16:06:37  Christoph Stoidner Edit header
 2    IPC@CHIP  1.1         13.08.2001 15:29:06  Christoph Stoidner edit
 1    IPC@CHIP  1.0         13.08.2001 15:27:00  Christoph Stoidner 
$

*
* History       :
*
*  Vx.yy                   Author  Changes
*
*  V1.00      17.07.00     roth    Create
*
*  -------------------------------------------------------------------------
*  Published on the Beck WebSite with kindlier permission of Bernhard Roth.
****************************************************************************/

#ifndef __I2CAPI_H__
#define __I2CAPI_H__

#define I2CINT         0xAA

/*************************************************************************/
// I2C Api Services
/*************************************************************************/
#define I2C_INIT             0x80
#define I2C_SCAN             0x81
#define I2C_TRANS_RECV_CHAR  0x82
#define I2C_TRANS_RECV_BLOCK 0x83
#define I2C_RELEASE          0x84
#define I2C_RESTART          0x8B
#define I2C_SELECT_CLK_PIN   0x8E
#define I2C_SELECT_DATA_PIN  0x8F

/*************************************************************************/
//prototypes
/*************************************************************************/

void I2C_init (void);
void I2C_release (void);
void I2C_restart (void);
unsigned char I2C_scan (unsigned char start_addr, unsigned char end_addr);
int I2C_transmit_block (unsigned char slave, char far * buffer, int length);
int I2C_receive_block (unsigned char slave, char far * buffer, int length);
int I2C_transmit_char (unsigned char slave, char c);
int I2C_receive_char (unsigned char slave, char * c, unsigned char lastchar);
void I2C_select_clock_pin(unsigned char pio_no);
void I2C_select_data_pin(unsigned char pio_no);

/*************************************************************************/
#endif /* __I2CAPI_H__*/
/*************************************************************************/
//end i2c_api.h
/*************************************************************************/