/* * *
 * DANCER.C
 *
 * Diese Datei implementiert die Hauptfunktion der Software von nic, unserem
 * kleinen Roboter. Sie ist das Ergebnis des Heiligenhoven-Wochenendes vom
 * 19. bis 21. April.
 *
 * Kurze Erluterung:
 * Eine Schleife stellt sozusagen das "threading" dar. In ihr werden stndig
 * die Eingnge abgefragt und bei Bedarf entsprechende Aktionen durchgefhrt.
 *
 * gbf, 21.04.02
 * * */



#include <stdio.h>
#include <stdlib.h>
#include <fossil.c>
#include <rtos.c>
#include <hwapi.c>
#include "nicapi.h"     // unsr eigenes api zur kontrolle von nic
#include "liste.h"      // doppelt verkettete liste fr message queue


#define TRUE 1          // wahr
#define FALSE 0         // nicht ganz so wahr
#define TCP_INT 0xAC
typedef unsigned char BOOL;


union  REGS  inregs;    // bentigt fr interrupt-handling
union  REGS  outregs;

int timerCount = 0;     // anzahl timeraufrufe. mainly debug
int sens_status = 0;    // status der eingnge am fischer-interface
int duration = 0;       // lebensdauer des aktuellen motorenstatus
char timerReady = FALSE;// flag, dass der timer aufgerufen wurde.
unsigned long lastActionTimeStamp = 0; // bei welchem clocktickcount der
																			 // letzte motorenbefehl gesendet wurde.
																			 // beugt flankenstress bei fwd-bkwd
																			 // vor.


void byte2string(char s[9], int b)
{
	for(int i=0; i < 8; i++)
	{
		if((b & (1 << i)) != 0)
		{
			s[7-i] = '1';
		}
		else
		{
			s[7-i] = '0';
		}
	}
	s[8] = '\0';
}



void huge TimerDoThis(void)  // die vom timer aufgerufene funktion
{
	unsigned long l;

	RTX_Get_System_Ticks(&l);  // clocktickcount einlesen
	if(abs(l - lastActionTimeStamp) > 100) // wenn schon seit ner zehntel-
	{                                      // sekunde kein radtick mehr...
		timerReady = TRUE;                   // ...dann muck auf
		timerCount++;
	}
//  RTX_Sleep_Time(1);
}

void main(void)                  // eine wunderschne mainfunktion
{
	// declarations
	BOOL ende = FALSE;             // ende-flag fr die mainschleife

	nic_init();                    // nic (mainly fossil) initialisieren
/*
	// timer initialisieren
	int timerID;                   // der handle fr den timer
	TimerProc_Structure tpc;       // RTX-spezifisches teil
	tpc.proc = (TimerDoThis);      // pointer auf dothis
	tpc.dummyptr = NULL;
	tpc.name[0] = '1';
	tpc.name[1] = '1';
	tpc.name[2] = '1';
	tpc.name[3] = '1';
	tpc.interval = 100;            // alle 100 ms machen...
	printf("inst: %d\n", RTX_Install_Timer(&tpc));
	timerID = *tpc.timerID;
	printf("start: %d\n", RTX_Start_Timer(timerID));
	// ende timer initialisieren
*/

	// liste initialisieren
	list dance;
	dance.head = NULL;
	dance.tail = NULL;
	listnode actAction;
	// ende liste

	FILE *in;
	if((in = fopen("COMMANDS.TXT", "rt")) == NULL)
	{
		printf("\nerr01: opening file COMMANDS.TXT. using precompiled.");
	 	actAction.interface = 0xC1;     // tanz vorbereiten
		actAction.status    = FORWARD;
		actAction.duration  = 10000;
		dance.add(actAction);
/*
		actAction.interface = 0xC1;
		actAction.status    = LEFT;
		actAction.duration  = 90;
		dance.add(actAction);

		actAction.interface = 0xC1;
		actAction.status    = FORWARD;
		actAction.duration  = 400;
		dance.add(actAction);

		actAction.interface = 0xC1;
		actAction.status    = RIGHT;
		actAction.duration  = 300;
		dance.add(actAction);


	// back

		actAction.interface = 0xC1;
		actAction.status    = LEFT;
		actAction.duration  = 300;
		dance.add(actAction);

		actAction.interface = 0xC1;
		actAction.status    = BACKWARD;
		actAction.duration  = 400;
		dance.add(actAction);

		actAction.interface = 0xC1;
		actAction.status    = RIGHT;
		actAction.duration  = 90;
		dance.add(actAction);

		actAction.interface = 0xC1;
		actAction.status    = BACKWARD;
		actAction.duration  = 600;
		dance.add(actAction);
*/
	}
	else 									// datei da, sie wird geparst
	{
		char buff[64];
		char c;
		int i;

		i = 0;
		while(!feof(in))
		{
			c = fgetc(in);
			if(c == '\n')
			{
				buff[i] = '\0';
				printf("\"%s\"", buff);
				actAction.interface = 0xC1;	

				switch(buff[0])
				{
					case 'L': actAction.status = LEFT; break;
					case 'R': actAction.status = RIGHT; break;
					case 'F': actAction.status = FORWARD; break;
					case 'B': actAction.status = BACKWARD; break;
					default: printf("\nerr02: parsing: first char in a row not LRFB. last line empty?"); exit(1);
				}

				for(i=0; buff[i] != '\0'; i++) buff[i] = buff[i+1];
				actAction.duration = atoi(buff);
				i = 0;
				dance.add(actAction);
			}
			else
			{
				buff[i++] = c;
			}
		}
	}

	printf("liste fertig.\n");  			// debugstat

	pfe_enable_pcs(6);                // ios vorbereiten
	outportb(0x600, 0);
	
	int started = 0;               // dieser part wartet auf den klick
	while (!(started & 128)) {     // des start-tasters
		fossil_putbyte_wait(1, 0xC1);
		fossil_putbyte_wait(1, 0X00);
		started = fossil_getbyte_wait(1);
		RTX_Sleep_Time(100);
	}
	
	BOOL laststate = ~inportb(0x600); // erste flanke sicherstellen
	BOOL doaction = FALSE;

	int ticks = 0;                    // gezhlte ticks
	unsigned int ioState;             // statusbyte der ipc-eingnge

	char sbuff[9];

	while(!ende)                      // main-loop
	{
		ioState = inportb(0x600);       // eingnge einlesen
//		hal_get_pio_output_state(&ioState, 1);

		if(ioState != laststate)        // wenn sich am eingang was gendert hat
		{                               // es also einen flankenwechsel gab
			ticks++;                      // dann dies als tick werten
			doaction = TRUE;              // und die tickAction freigeben
			laststate = ioState;          // zur prfung ob flanke
		}
//		printf("\t%3d", ioState);
/*                                  dies war ein test, um nur jeden x-ten
		printf("\nif doaction");        tick zu werten. verworfen.
		if(doaction)
		{
			if(XthTick >= everyXthTick)
			{
				printf("\nxthkick=1");
				XthTick = 1;
			}
			else
			{
				printf("\ndoaction=FALSE");
				doaction = FALSE;
				XthTick++;
			}
		}
*/

//		if(timerReady)
		if(doaction || timerReady) // wenn tick oder timer okay gegeben haben
		{
			byte2string(sbuff, ioState);
						
						
			if(duration <= 0)        // wenn aktuelles listenelement abgearbeitet
			{
//				printf("lese listenelement ein\n");
				ende = (dance.pop(&actAction) != 0); // neuen befehl einlesen
				duration = actAction.duration;       // und eventuell abbrechen
			}

			nic_move(actAction.status);  // nicbewegung vorbereiten
//			api_sleep(20);

			printf("%s  ", sbuff);
			printf("if%02x  ", nic_interface); // debug-output
			printf("st%02x  ", nic_status);
			printf("du%3d  ", duration);
			printf("en%d\n", ende);

//			printf("%d\n", sens_status);

			RTX_Get_System_Ticks(&lastActionTimeStamp); // timestamp fttern
			timerReady = FALSE;           // flags in ursprungszustand versetzen
			doaction = FALSE;

			duration--;        // aktueller befehl wurde ein mal abgearbeitet
		}

		sens_status = nic_execute();    // nic in bewegung versetzen
	}

	while(dance.head != NULL) dance.del();  // liste leeeren, nur so
																					// sicherheitshalber. ist theore-
																					// tisch schon leer.

	nic_stop();                             // nic stoppen
	nic_execute();
//  RTX_Get_System_Ticks(&l); printf("\n\n%ld\n", l);

//	printf("stop: %d\n", RTX_Stop_Timer(timerID));   // rckgabe der timerf.
//	printf("remv: %d\n", RTX_Remove_Timer(timerID)); // ausgeben

	printf("tickcount: %d\n\n", ticks);              // schnickschnack
	nic_deinit();

	//rebooting the SC12
	inregs.h.ah = 0x21;             // und er steigt wie phoenix aus der asche
	int86(0xA0,&inregs,&outregs);   // wieder auf.

}
